/* o_spc.c - Whitespace optimizations - Don Yang / Dave Newquist / John Rapp

   07/26/01
                                                                           */

#include<stdio.h>
#include"token.h"
#include"tree.h"


/************************************************************ o_whitespace */
int o_whitespace(Node **node)
{
   int modified, space;

   modified = space = 0;
   if( (*node)->attr.tt )
   {
      /* Typewrite mode, preserve all whitespaces */
      while( *node )
      {
         if( (*node)->tree )
            modified |= o_whitespace(&((*node)->tree));
         node = &((*node)->next);
      }
      return modified;
   }

   /* Remove all consecutive spaces at this level */
   while( *node )
   {
      if( (*node)->token->type == TokenSpace )
      {
         if( space )
         {
            /* Consolidate */
            DeleteNode(node);    /* (tree.c) */
            modified = 1;
            continue;
         }
         else
         {
            /* Print first space */
            space = 1;
         }
      }
      else
      {
         /* Non-whitespace */
         if( (*node)->tree )
            modified |= o_whitespace(&((*node)->tree));
         space = 0;
      }
      node = &((*node)->next);
   }

   return modified;

} /* o_whitespace() */
