/* o_under.c - Underscore optimizations - Don Yang / Dave Newquist / John Rapp

   07/26/01
                                                                           */

#include<stdio.h>
#include"smlng.h"
#include"token.h"
#include"tree.h"


/* Local functions */
static int r_underscore(Node **node, int level);

/************************************************************ o_underscore */
int o_underscore(Node **node)
{
   return r_underscore(node, 0);

} /* o_underscore() */


/************************************************************ r_underscore */
static int r_underscore(Node **node, int level)
{
   int modified;

   modified = 0;
   while( *node != NULL )
   {
      if( (*node)->tree )
      {
         /* Optimize subtree */
         if( (*node)->token->type == TagU )
         {
            /* Underscore tag */
            if( level < MAX_U_LEVEL )
            {
               modified |= r_underscore(&((*node)->tree), level + 1);
               node = &((*node)->next);
            }
            else
            {
               /* Maximum underline level reached, remove tag */
               PromoteSubtree(node);      /* (tree.c) */
            }
         }
         else
         {
            /* Unrelated tag */
            modified |= r_underscore(&((*node)->tree), level);
            node = &((*node)->next);
         }
      }
      else
      {
         node = &((*node)->next);
      }
   }
   return modified;

} /* r_underscore() */
