/* opt.c - Optimizer front end - Don Yang / Dave Newquist / John Rapp

   07/26/01
                                                                           */

#include<stdio.h>
#include"main.h"
#include"opt.h"
#include"tree.h"


/* Optimizers - easier to list them all here instead of creating a
   separate header file for each routine.                            */

extern int o_duplicate(Node**);        /* (o_dup.c) */
extern int o_empty(Node**);            /* (o_empty.c) */
extern int o_underscore(Node**);       /* (o_under.c) */
extern int o_whitespace(Node**);       /* (o_spc.c) */

/**************************************************************** Optimize */
void Optimize(Node **node)
{
   int modified;
   #ifndef NDEBUG
      int pass = 0;
   #endif

   o_underscore(node);

   do
   {
      #ifndef NDEBUG
         fprintf(stderr, "optimize pass %d\n", ++pass);
      #endif

      /* All these should be merged to one function instead of
         doing multiple passes, but it's easier to debug this way */
      if( LimitBreak )  return;     modified =  o_empty(node);
      if( LimitBreak )  return;     modified |= o_duplicate(node);
      if( LimitBreak )  return;     modified |= o_whitespace(node);

   } while( modified );

} /* Optimize() */
